// src/schedulable_state_widget.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef SCHEDULABLE_STATE_WIDGET_HH
#define SCHEDULABLE_STATE_WIDGET_HH 1



#include <sgpemv2/schedulable.hh>
#include "cairo_elements.hh"
#include "cairo_widget.hh"

#include <sgpemv2/templates/smartp.tcc>

#include "gtkmm/tooltips.h"

namespace sgpem
{
  class SchedulableStateWidget : public CairoWidget
  {
  public:
    SchedulableStateWidget(Schedulable::state st);
    ~SchedulableStateWidget();

    void set_state(Schedulable::state new_state);

  protected:
    virtual void draw_widget(cairo_t* ctx);

    // with this method CairoWidget tells the needed drawing dimensions
    virtual void calc_drawing_size(size_t& width, size_t& height) const;

    // with this method CairoWidget tells the needed widget dimensions
    virtual void calc_widget_size(size_t& width, size_t& height) const;

  private:
    static memory::smart_ptr<Gtk::Tooltips>  _global_ttips;

    Color          _color;
    memory::smart_ptr<Gtk::Tooltips>         _ttips;
  };

} //~ namespace sgpem


#endif //~ SCHEDULABLE_STATE_WIDGET_HH
